#ifndef MOLECULE_H
#define MOLECULE_H

#include "../General/General/String.h"

class Molecule
{
private:
	double __num, __numPrev, __volume, __k[6];
	String __name;
	bool __fix;

	double __mu, __sigma2, __error;
	
public:
	double num();
	double numPrev();
	String name();
	double volume();
	void fix(bool f);
	
	Molecule(String name, double volume, double num);
	
	void updateNum(double delta);
	void copyToNumPrev();

	double k(int index);
	void initK();
	void addK(int index, double value);
	void multiplyDtToK(int index, double dt);
	double kSum(const double weight[]);
	void updateNum(const double kWeight[]);

	void restoreNumPrev();

	//tau leap
	void initMuSigmaError();
	void updateError(double error);
	bool reactantOfNonCritical();
	double tau1(double errorCoef);
	void addMuSigma(double mu, double sigma2);
};

#endif
