#ifndef STIMULUS_H
#define STIMULUS_H

class Molecule;

class Stimulus
{
friend bool Stimulus_compare(const Stimulus* stimulus0, const Stimulus* stimulus1);

private:
	Molecule* __molecule;
	double __timeBegin, __numPerTime, __stochasticity, __numFinished;
	int __num;

public:
	Stimulus(Molecule* molecule, double timeBegin, double duration, int num);
	bool step(double time);
	double timeBegin();
	void stochasticity(double s);
	bool finished();
};

bool Stimulus_compare(const Stimulus* stimulus0, const Stimulus* stimulus1);

#endif
