#include "UnitConversion.h"

const double UnitConversion::AVOGADRO=6e+23;

double UnitConversion::um3_to_l(double value)
{
	return value*1e-15;
}

double UnitConversion::num_to_umol(double num)
{
	return num/AVOGADRO*1e+6;
}

double UnitConversion::umol_to_num(double umol)
{
	return umol*AVOGADRO/1e+6;
}

double UnitConversion::num_um3_to_uM(double num, double volume)
{
	return num_to_umol(num)/um3_to_l(volume);
}

double UnitConversion::uM_um3_to_num(double uM, double volume)
{
	return umol_to_num(uM)*um3_to_l(volume);
}
