#include "Model.h"
#include "Result.h"
#include "../General/Random/Random.h"
#include <fstream>

void runStochastic(double volume, double PFCVInterval, vector<double> ampPF, int randSeed, const char* file)
{
	Model model;
	model.setStim(PFCVInterval, ampPF);
	model.setStocahsticity(1.0/volume);
	model.tauLeap(true);
	Random random(randSeed);
	model.run(&random);
	ofstream ofs(file);
	model.result()->saveConc(ofs);
}

void runDeterministic(double PFCVInterval, vector<double> ampPF, const char* file)
{
	Model model;
	model.setStim(PFCVInterval, ampPF);
	model.setStocahsticity(0);
	model.tauLeap(true);
	model.run(NULL);
	ofstream ofs(file);
	model.result()->saveConc(ofs);
}

int main(int argc, char* argv[])
{
	double volume=1;
	double PFCVInterval=0.16;
	vector<double> ampPF;
	ampPF.push_back(1);
	ampPF.push_back(1);
	ampPF.push_back(1);
	ampPF.push_back(1);
	ampPF.push_back(1);
	int randSeed=0;
	char file[]="output.txt";

	runStochastic(volume, PFCVInterval, ampPF, randSeed, file);
	//runDeterministic(PFCVInterval, ampPF, file);
}
